---
- name: Install python3, docker, docker-compose
  hosts: docker_server
  become: yes # enable root user, become: yes = become_user: root
  gather_facts: False # tell ansible to not execute the task on the first play
  tasks:
    - name: Install python3 and docker
      vars:
        ansible_python_interpreter: /usr/bin/python # use python2 when installing python3
      ansible.builtin.yum: # also need to use python2 when using yum to intall packages
        name: 
          - python3
          - docker
        update_cache: yes
        state: present
    - name: Install Docker-compose # docker-compose is not a yum package
      ansible.builtin.get_url: 
      # lookup plugins are ansible-specific extension to the Jinja2 templating language
      # They allow Ansible to access data from outside sources
      # "pipe" is an ansible lookup plugin
      # it calbulates the output of the shell command and pipes it to the left side of the lookup
        #url: https://github.com/docker/compose/releases/download/2.18.0/docker-compose-linux-{{lookup('pipe', 'uname -m')}}
        url: https://github.com/docker/compose/releases/download/v2.18.1/docker-compose-linux-aarch64
        dest: /usr/local/bin/docker-compose
        mode: +x
    - name: Start docker daemon
      ansible.builtin.systemd: # systemd module is basically a systemctl
        name: docker
        state: started # start docker
    - name: Install docker python module
      ansible.builtin.pip: # servers with different Linux distributions require different configurations
        name: 
          - docker
          - docker-compose
    

- name: Add ec2-user to docker group
  hosts: docker_server
  become: yes # we need root user for this task
  tasks: 
    - name: Add ec2-user to docker group
      ansible.builtin.user: # user module allows us to create a user or add an existing user to a group
        name: ec2-user
        groups: docker
        append: yes
    - name: Reconnect to server session
      ansible.builtin.meta: reset_connection


- name: Start docker containers
  hosts: docker_server
  vars_files:
    - vars.yaml
  # playbook prompts the user for certain input, prompting the user for variables lets us avoid recording
  # sensitive data like passwords. We can also encrypt the entered values.
  #vars_prompt: # interactive input: prompts
    #- name: docker_password
      #prompt: Enter Dockerhub password
  tasks:
    - name: Copy docker compose
      ansible.builtin.copy:
        src: /Users/joeyhan/DevOps/TWN_Bootcamp/Projects/ansible/ansible-docker-deploy-on-ec2/docker-compose.yaml
        dest: /home/ec2-user/docker-compose.yaml # copy docker-compose file to server
    - name: Docker login
      community.docker.docker_login: # authenticate with a docker registry and adds the credentials to our local Docker config file
        registry_url: https://index.docker.io/v1/
        username: codingtruckingjoe
        password: "{{docker_password}}"
    - name: Start container from compose
      community.docker.docker_compose: # docker_compose module allows us to execute docker-compose.yaml file
        project_src: /home/ec2-user
        state: present # default, we can go without it, present=docker-compose up, absent=docker-compose down   